//---------------------------------------------------------------------------
#ifndef AT90CAN32H
#define AT90CAN32H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool AT90CAN32_ProgrammingEnable();                    //    
bool AT90CAN32_ChipErase();                            //  EEPROM  flash
bool AT90CAN32_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool AT90CAN32_LoadProgramMemoryPage(unsigned int);    //      128-     
bool AT90CAN32_WriteProgramMemoryPage(unsigned int);   //   128-     
bool AT90CAN32_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool AT90CAN32_WriteEEPROMMemory(unsigned int);        //   EEPROM   8-       
//---
bool AT90CAN32_ReadLockBits();                    //  Lock- (  Area3[3])
bool AT90CAN32_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int AT90CAN32_ReadSignatureBytes();      //    (  )
bool AT90CAN32_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool AT90CAN32_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool AT90CAN32_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool AT90CAN32_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool AT90CAN32_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool AT90CAN32_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool AT90CAN32_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
