//---------------------------------------------------------------------------
#ifndef ATmega16H
#define ATmega16H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega16_ProgrammingEnable();                    //    
bool ATmega16_ChipErase();                            //  EEPROM  flash
bool ATmega16_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega16_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega16_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega16_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega16_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega16_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATmega16_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATmega16_ReadSignatureBytes();      //    (  )
bool ATmega16_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega16_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega16_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega16_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega16_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
