//---------------------------------------------------------------------------
#ifndef ATmega161H
#define ATmega161H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega161_ProgrammingEnable();                    //    
bool ATmega161_ChipErase();                            //  EEPROM  flash
bool ATmega161_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega161_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega161_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega161_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega161_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega161_ReadLockBits();                    //  Lock- (  Area3[1])
bool ATmega161_WriteLockBits();                   //  Lock- (  Area3[1])
unsigned int ATmega161_ReadSignatureBytes();      //    (  )
bool ATmega161_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega161_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
//---------------------------------------------------------------------------
#endif
