//---------------------------------------------------------------------------
#ifndef ATmega162H
#define ATmega162H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega162_ProgrammingEnable();                    //    
bool ATmega162_ChipErase();                            //  EEPROM  flash
bool ATmega162_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega162_LoadProgramMemoryPage(unsigned int);    //      128-     
bool ATmega162_WriteProgramMemoryPage(unsigned int);   //   128-     
bool ATmega162_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega162_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega162_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega162_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega162_ReadSignatureBytes();      //    (  )
bool ATmega162_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega162_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega162_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega162_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega162_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega162_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega162_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
