//---------------------------------------------------------------------------
#ifndef ATmega163H
#define ATmega163H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega163_ProgrammingEnable();                    //    
bool ATmega163_ChipErase();                            //  EEPROM  flash
bool ATmega163_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega163_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega163_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega163_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega163_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega163_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATmega163_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATmega163_ReadSignatureBytes();      //    (  )
bool ATmega163_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega163_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega163_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega163_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega163_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
