//---------------------------------------------------------------------------
#ifndef ATmega164H
#define ATmega164H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega164_ProgrammingEnable();                    //    
bool ATmega164_ChipErase();                            //  EEPROM  flash
bool ATmega164_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega164_LoadProgramMemoryPage(unsigned int);    //      128-     
bool ATmega164_WriteProgramMemoryPage(unsigned int);   //   128-     
bool ATmega164_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega164_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega164_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega164_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega164_ReadSignatureBytes();      //    (  )
bool ATmega164_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega164_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega164_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega164_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega164_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega164_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega164_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
