//---------------------------------------------------------------------------
#ifndef ATmega169H
#define ATmega169H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega169_ProgrammingEnable();                    //    
bool ATmega169_ChipErase();                            //  EEPROM  flash
bool ATmega169_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega169_LoadProgramMemoryPage(unsigned int);    //      128-     
bool ATmega169_WriteProgramMemoryPage(unsigned int);   //   128-     
bool ATmega169_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega169_WriteEEPROMMemory(unsigned int);        //    EEPROM   
bool ATmega169_LoadEEPROMMemoryPage(unsigned int);     //   EEPROM   8-    
bool ATmega169_WriteEEPROMMemoryPage(unsigned int);    //   8-  EEPROM   
//---
bool ATmega169_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega169_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega169_ReadSignatureBytes();      //    (  )
bool ATmega169_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega169_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega169_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega169_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega169_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega169_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega169_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
