//---------------------------------------------------------------------------
#ifndef ATmega323H
#define ATmega323H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega323_ProgrammingEnable();                    //    
bool ATmega323_ChipErase();                            //  EEPROM  flash
bool ATmega323_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega323_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega323_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega323_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega323_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega323_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATmega323_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATmega323_ReadSignatureBytes();      //    (  )
bool ATmega323_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega323_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega323_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega323_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega323_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
