//---------------------------------------------------------------------------
#ifndef ATmega48H
#define ATmega48H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega48_ProgrammingEnable();                    //    
bool ATmega48_ChipErase();                            //  EEPROM  flash
bool ATmega48_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega48_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega48_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega48_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega48_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega48_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega48_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega48_ReadSignatureBytes();      //    (  )
bool ATmega48_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega48_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega48_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega48_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega48_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega48_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega48_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
