//---------------------------------------------------------------------------
#ifndef ATmega603H
#define ATmega603H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega603_ProgrammingEnable();                    //    
bool ATmega603_ChipErase();                            //  EEPROM  flash
bool ATmega603_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega603_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega603_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega603_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega603_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega603_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega603_WriteLockBits();                   //  Lock- (  Area3[3])
bool ATmega603_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega603_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
unsigned int ATmega603_ReadSignatureBytes();      //    (  )
//---------------------------------------------------------------------------
#endif
