//---------------------------------------------------------------------------
#ifndef ATmega64H
#define ATmega64H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega64_ProgrammingEnable();                    //    
bool ATmega64_ChipErase();                            //  EEPROM  flash
bool ATmega64_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega64_LoadProgramMemoryPage(unsigned int);    //      128-     
bool ATmega64_WriteProgramMemoryPage(unsigned int);   //   128-     
bool ATmega64_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega64_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega64_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega64_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega64_ReadSignatureBytes();      //    (  )
bool ATmega64_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega64_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega64_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega64_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega64_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega64_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega64_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
