//---------------------------------------------------------------------------
#ifndef ATmega640H
#define ATmega640H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega640_ProgrammingEnable();                    //    
bool ATmega640_ChipErase();                            //  EEPROM  flash
bool ATmega640_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega640_LoadProgramMemoryPage(unsigned int);    //      128-     
bool ATmega640_WriteProgramMemoryPage(unsigned int);   //   128-     
bool ATmega640_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega640_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega640_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATmega640_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATmega640_ReadSignatureBytes();      //    (  )
bool ATmega640_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega640_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega640_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega640_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega640_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega640_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATmega640_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
