//---------------------------------------------------------------------------
#ifndef ATmega8H
#define ATmega8H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega8_ProgrammingEnable();                    //    
bool ATmega8_ChipErase();                            //  EEPROM  flash
bool ATmega8_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega8_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega8_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega8_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega8_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega8_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATmega8_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATmega8_ReadSignatureBytes();      //    (  )
bool ATmega8_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega8_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega8_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega8_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega8_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
