//---------------------------------------------------------------------------
#ifndef ATmega8515H
#define ATmega8515H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATmega8515_ProgrammingEnable();                    //    
bool ATmega8515_ChipErase();                            //  EEPROM  flash
bool ATmega8515_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATmega8515_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATmega8515_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATmega8515_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATmega8515_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATmega8515_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATmega8515_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATmega8515_ReadSignatureBytes();      //    (  )
bool ATmega8515_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega8515_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega8515_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATmega8515_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATmega8515_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
