//---------------------------------------------------------------------------
#ifndef ATtiny12H
#define ATtiny12H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny12_ProgrammingEnable();                    //    
bool ATtiny12_ChipErase();                            //  EEPROM  flash
bool ATtiny12_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny12_WriteProgramMemory(unsigned int);   	  //      
bool ATtiny12_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny12_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATtiny12_ReadLockBits();                    //  Lock- (  Area3[1])
bool ATtiny12_WriteLockBits();                   //  Lock- (  Area3[1])
unsigned int ATtiny12_ReadSignatureBytes();      //    (  )
bool ATtiny12_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny12_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny12_ReadCalibrationBytes();            //    (   Area4)
bool ATtiny12_WriteFFTo0ProgramMemory();         //   flash 0xFF   0x0
//---------------------------------------------------------------------------
#endif
