//---------------------------------------------------------------------------
#ifndef ATtiny13H
#define ATtiny13H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny13_ProgrammingEnable();                    //    
bool ATtiny13_ChipErase();                            //  EEPROM  flash
bool ATtiny13_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny13_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATtiny13_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATtiny13_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny13_WriteEEPROMMemory(unsigned int);        //    EEPROM   
bool ATtiny13_LoadEEPROMMemoryPage(unsigned int);     //   EEPROM   4-    
bool ATtiny13_WriteEEPROMMemoryPage(unsigned int);    //   4-  EEPROM   
//---
bool ATtiny13_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATtiny13_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATtiny13_ReadSignatureBytes();      //    (  )
bool ATtiny13_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny13_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny13_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny13_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny13_ReadCalibrationBytes();            //    (   Area4)
bool ATtiny13_PollRDYBSY();                      // ,     (1 - , 0 - )
//---------------------------------------------------------------------------
#endif
