//---------------------------------------------------------------------------
#ifndef ATtiny15H
#define ATtiny15H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny15_ProgrammingEnable();                    //    
bool ATtiny15_ChipErase();                            //  EEPROM  flash
bool ATtiny15_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny15_WriteProgramMemory(unsigned int);   	  //      
bool ATtiny15_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny15_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATtiny15_ReadLockBits();                    //  Lock- (  Area3[1])
bool ATtiny15_WriteLockBits();                   //  Lock- (  Area3[1])
unsigned int ATtiny15_ReadSignatureBytes();      //    (  )
bool ATtiny15_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny15_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny15_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
