//---------------------------------------------------------------------------
#ifndef ATtiny22H
#define ATtiny22H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Fuse Byte (0 - RCEN, 5 - SPIEN), 1 - Lock byte (1 - LB1, 2 - LB2)
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny22_ProgrammingEnable();                     //    
bool ATtiny22_ChipErase();                             //  EEPROM  flash
bool ATtiny22_ReadProgramMemory(unsigned int, bool);   //      , 0 - , 1 - 
bool ATtiny22_WriteProgramMemory(unsigned int);        //      
bool ATtiny22_ReadEEPROMMemory(unsigned int, bool);    //   EEPROM   , 0 - , 1 - 
bool ATtiny22_WriteEEPROMMemory(unsigned int);         //    EEPROM   
//---
bool ATtiny22_ReadLockFuseBits();                //  Lock-  Fuse- (  Area3[1], Area3[0])
bool ATtiny22_WriteLockBits();                   //  Lock- (  Area3[1])
bool ATtiny22_WriteFuseBits();                   //  Fuse- (Fuse Byte - Area3[0])
unsigned int ATtiny22_ReadSignatureBytes();      //    (  )
//---------------------------------------------------------------------------
#endif
