//---------------------------------------------------------------------------
#ifndef ATtiny2313H
#define ATtiny2313H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny2313_ProgrammingEnable();                    //    
bool ATtiny2313_ChipErase();                            //  EEPROM  flash
bool ATtiny2313_ReadProgramMemory(unsigned int, bool);  //       , 0 - , 1 - 
bool ATtiny2313_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATtiny2313_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATtiny2313_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny2313_WriteEEPROMMemory(unsigned int);        //   EEPROM   4-    
//---
bool ATtiny2313_ReadFuseLockBits();                //  Fuse- & Lock-
bool ATtiny2313_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATtiny2313_ReadSignatureBytes();      //    (  )
bool ATtiny2313_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny2313_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny2313_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATtiny2313_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
