//---------------------------------------------------------------------------
#ifndef ATtiny25H
#define ATtiny25H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny25_ProgrammingEnable();                    //    
bool ATtiny25_ChipErase();                            //  EEPROM  flash
bool ATtiny25_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny25_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATtiny25_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATtiny25_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny25_WriteEEPROMMemory(unsigned int);        //    EEPROM   
bool ATtiny25_LoadEEPROMMemoryPage(unsigned int);     //   EEPROM   4-    
bool ATtiny25_WriteEEPROMMemoryPage(unsigned int);    //   4-  EEPROM   
//---
bool ATtiny25_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATtiny25_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATtiny25_ReadSignatureBytes();      //    (  )
bool ATtiny25_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny25_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny25_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATtiny25_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny25_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny25_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATtiny25_ReadCalibrationBytes();            //    (   Area4)
bool ATtiny25_PollRDYBSY();                      // ,     (1 - , 0 - )
//---------------------------------------------------------------------------
#endif
