//---------------------------------------------------------------------------
#ifndef ATtiny26H
#define ATtiny26H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny26_ProgrammingEnable();                    //    
bool ATtiny26_ChipErase();                            //  EEPROM  flash
bool ATtiny26_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny26_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATtiny26_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATtiny26_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny26_WriteEEPROMMemory(unsigned int);        //    EEPROM   
//---
bool ATtiny26_ReadLockBits();                    //  Lock- (  Area3[2])
bool ATtiny26_WriteLockBits();                   //  Lock- (  Area3[2])
unsigned int ATtiny26_ReadSignatureBytes();      //    (  )
bool ATtiny26_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny26_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny26_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny26_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny26_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
