//---------------------------------------------------------------------------
#ifndef ATtiny261H
#define ATtiny261H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- Area3:  0 - Low Byte, 1 - High byte, 2 - Extended byte, 3 - Lock byte
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool ATtiny261_ProgrammingEnable();                    //    
bool ATtiny261_ChipErase();                            //  EEPROM  flash
bool ATtiny261_ReadProgramMemory(unsigned int, bool);  //      , 0 - , 1 - 
bool ATtiny261_LoadProgramMemoryPage(unsigned int);    //      16-     
bool ATtiny261_WriteProgramMemoryPage(unsigned int);   //   16-     
bool ATtiny261_ReadEEPROMMemory(unsigned int, bool);   //   EEPROM   , 0 - , 1 - 
bool ATtiny261_WriteEEPROMMemory(unsigned int);        //   EEPROM   4-       
//---
bool ATtiny261_ReadLockBits();                    //  Lock- (  Area3[3])
bool ATtiny261_WriteLockBits();                   //  Lock- (  Area3[3])
unsigned int ATtiny261_ReadSignatureBytes();      //    (  )
bool ATtiny261_WriteFuseBits();                   //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny261_WriteFuseHighBits();               //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny261_WriteFuseExtendedBits();           //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATtiny261_ReadFuseBits();                    //  Fuse- (Low Fuse Byte      - Area3[0])
bool ATtiny261_ReadFuseHighBits();                //  Fuse- (High Fuse Byte     - Area3[1])
bool ATtiny261_ReadFuseExtendedBits();            //  Fuse- (Extended Fuse Byte - Area3[2])
bool ATtiny261_ReadCalibrationBytes();            //    (   Area4)
//---------------------------------------------------------------------------
#endif
