//---------------------------------------------------------------------------
#ifndef AVRFunctionsH
#define AVRFunctionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- ,       ---------------
//---------------------------------------------------------------------------
#define PC_WORK         0x8     // PC32 = 10 (  +12, +5    ,   = 0)
#define PD_WORK         0x14    // PD42 = 11 (   WR = 1, OE = 1,   PG  ,   ,   0)
//---------------------------------------------------------------------------
//--- ,     -----------------------------
//---------------------------------------------------------------------------
//---   C ---
#define Pagel   5
#define XA1     4
#define V12     3
#define V5      2
#define BS1     1
#define RDY     0
//---   D ---
#define BS2     7
#define XA0     6
#define PG      5
#define WR      4
#define XTAL    3
#define OE      2
//---------------------------------------------------------------------------
//---   () ----------------------------------------------
//---------------------------------------------------------------------------
#define CYCLES  50                       //     RDY
#define PAUSE   1                        //     RDY
bool WaitRDYHigh(void);                  //     RDY
bool PhaseA(unsigned char);              // A - Load Command
bool PhaseB(unsigned char);              // B - Load Address Low Byte
bool PhaseC(unsigned char);              // C - Load Address High Byte
bool PhaseD(unsigned char);              // D - Load Data Low Byte
bool PhaseE(unsigned char);              // E - Load Data High Byte
bool PhaseF(unsigned char);              // F - Load Address extended High Byte
//---------------------------------------------------------------------------
//--- functions output: true - success, false - fail ------------------------
//---------------------------------------------------------------------------
bool EnterProgrammingMode();            //    
bool ExitProgrammingMode();             //    
unsigned int ReadSignatureBytes();      //    (  )
//---------------------------------------------------------------------------
#endif
 