//---------------------------------------------------------------------------
#pragma hdrstop

#include "ChipFunctions.h"      //     
#include "LogFunctions.h"       //      
#include "Main.h"               //      
#include "FormFunctions.h"      //     
#include "ProgressBar.h"        //   -
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
chip  SelectedChip;     //  
//---------------------------------------------------------------------------
//---       ------------------------
//---------------------------------------------------------------------------
void InitChip(unsigned int ID)
{ //   

  switch(ID)
  { case 0x2971E:      //   ATmega128
                SelectedChip.Name               = "ATmega128";         //  
                SelectedChip.ImageName          = "ATmega128.jpg";     //    
                SelectedChip.ID                 = 0x2971E;              //  
                SelectedChip.Area1Size          = 131072;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega128");  //   
                break;
    case 0x2981E:      //   ATmega2561
                SelectedChip.Name               = "ATmega2561";         //  
                SelectedChip.ImageName          = "ATmega2561.jpg";     //    
                SelectedChip.ID                 = 0x2981E;              //  
                SelectedChip.Area1Size          = 262144;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega2561");  //   
                break;
    case 0x1981E:      //   ATmega2560
                SelectedChip.Name               = "ATmega2560";         //  
                SelectedChip.ImageName          = "ATmega2560.jpg";     //    
                SelectedChip.ID                 = 0x1981E;              //  
                SelectedChip.Area1Size          = 262144;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega2560");  //   
                break;
    case 0x4971E:      //   ATmega1281
                SelectedChip.Name               = "ATmega1281";         //  
                SelectedChip.ImageName          = "ATmega1281.jpg";     //    
                SelectedChip.ID                 = 0x4971E;              //  
                SelectedChip.Area1Size          = 131072;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega1281");  //   
                break;
    case 0x3971E:      //   ATmega1280
                SelectedChip.Name               = "ATmega1280";         //  
                SelectedChip.ImageName          = "ATmega1280.jpg";     //    
                SelectedChip.ID                 = 0x3971E;              //  
                SelectedChip.Area1Size          = 131072;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega1280");  //   
                break;
    case 0x8961E:      //   ATmega640
                SelectedChip.Name               = "ATmega640";          //  
                SelectedChip.ImageName          = "ATmega640.jpg";      //    
                SelectedChip.ID                 = 0x8961E;              //  
                SelectedChip.Area1Size          = 65536;                //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega640");  //   
                break;
    case 0x2961E:      //   ATmega64
                SelectedChip.Name               = "ATmega64";           //  
                SelectedChip.ImageName          = "ATmega64.jpg";       //    
                SelectedChip.ID                 = 0x2961E;              //  
                SelectedChip.Area1Size          = 65536;                //  flash-  
                SelectedChip.Area2Size          = 2048;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega64");   //   
                break;
    case 0x1951E:      //   ATmega323
                SelectedChip.Name               = "ATmega323";           //  
                SelectedChip.ImageName          = "ATmega323.jpg";       //    
                SelectedChip.ID                 = 0x1951E;              //  
                SelectedChip.Area1Size          = 32768;                //  flash-  
                SelectedChip.Area2Size          = 1024;                 //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega323");  //   
                break;
    case 0x2951E:      //   ATmega32
                SelectedChip.Name               = "ATmega32";           //  
                SelectedChip.ImageName          = "ATmega32.jpg";       //    
                SelectedChip.ID                 = 0x2951E;              //  
                SelectedChip.Area1Size          = 32768;                //  flash-  
                SelectedChip.Area2Size          = 1024;                 //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega32");   //   
                break;
    case 0x5941E:      //   ATmega169
                SelectedChip.Name               = "ATmega169";          //  
                SelectedChip.ImageName          = "ATmega169.jpg";      //    
                SelectedChip.ID                 = 0x5941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega169");  //   
                break;
    case 0xA961E:      //   ATmega644
                SelectedChip.Name               = "ATmega644";          //  
                SelectedChip.ImageName          = "ATmega644.jpg";      //    
                SelectedChip.ID                 = 0xA961E;              //  
                SelectedChip.Area1Size          = 65536;                //  flash-  
                SelectedChip.Area2Size          = 2048;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega644");  //   
                break;
    case 0x8951E:      //   ATmega324
                SelectedChip.Name               = "ATmega324";           //  
                SelectedChip.ImageName          = "ATmega324.jpg";       //    
                SelectedChip.ID                 = 0x8951E;              //  
                SelectedChip.Area1Size          = 32768;                //  flash-  
                SelectedChip.Area2Size          = 1024;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega324");  //   
                break;
    case 0xA941E:      //   ATmega164
                SelectedChip.Name               = "ATmega164";           //  
                SelectedChip.ImageName          = "ATmega164.jpg";       //    
                SelectedChip.ID                 = 0xA941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega164");  //   
                break;
    case 0x2941E:      //   ATmega163
                SelectedChip.Name               = "ATmega163";           //  
                SelectedChip.ImageName          = "ATmega163.jpg";       //    
                SelectedChip.ID                 = 0x2941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega163");  //   
                break;
    case 0x4941E:      //   ATmega162
                SelectedChip.Name               = "ATmega162";           //  
                SelectedChip.ImageName          = "ATmega162.jpg";       //    
                SelectedChip.ID                 = 0x4941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega162");  //   
                break;
    case 0x1941E:      //   ATmega161
                SelectedChip.Name               = "ATmega161";           //  
                SelectedChip.ImageName          = "ATmega161.jpg";       //    
                SelectedChip.ID                 = 0x1941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega161");  //   
                break;
    case 0x3941E:      //   ATmega16
                SelectedChip.Name               = "ATmega16";           //  
                SelectedChip.ImageName          = "ATmega16.jpg";       //    
                SelectedChip.ID                 = 0x3941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega16");   //   
                break;
    case 0x8931E:      //   ATmega8535
                SelectedChip.Name               = "ATmega8535";         //  
                SelectedChip.ImageName          = "ATmega8535.jpg";     //    
                SelectedChip.ID                 = 0x8931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega8535"); //   
                break;
    case 0x6931E:      //   ATmega8515
                SelectedChip.Name               = "ATmega8515";         //  
                SelectedChip.ImageName          = "ATmega8515.jpg";     //    
                SelectedChip.ID                 = 0x6931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega8515"); //   
                break;
    case 0x7931E:      //   ATmega8
                SelectedChip.Name               = "ATmega8";            //  
                SelectedChip.ImageName          = "ATmega8.jpg";        //    
                SelectedChip.ID                 = 0x7931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega8");    //   
                break;
    case 0x6941E:      //   ATmega168
                SelectedChip.Name               = "ATmega168";          //  
                SelectedChip.ImageName          = "ATmega168.jpg";      //    
                SelectedChip.ID                 = 0x6941E;              //  
                SelectedChip.Area1Size          = 16384;                //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega168");   //   
                break;
    case 0xA931E:      //   ATmega88
                SelectedChip.Name               = "ATmega88";           //  
                SelectedChip.ImageName          = "ATmega88.jpg";       //    
                SelectedChip.ID                 = 0xA931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega88");   //   
                break;
    case 0x5921E:      //   ATmega48
                SelectedChip.Name               = "ATmega48";           //  
                SelectedChip.ImageName          = "ATmega48.jpg";       //    
                SelectedChip.ID                 = 0x5921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega48");   //   
                break;
    case 0x1971E:      //   ATmega103
                SelectedChip.Name               = "ATmega103";          //  
                SelectedChip.ImageName          = "ATmega103.jpg";      //    
                SelectedChip.ID                 = 0x1971E;              //  
                SelectedChip.Area1Size          = 131072;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega103");  //   
                break;
    case 0x1961E:      //   ATmega603
                SelectedChip.Name               = "ATmega603";          //  
                SelectedChip.ImageName          = "ATmega603.jpg";      //    
                SelectedChip.ID                 = 0x1961E;              //  
                SelectedChip.Area1Size          = 65536;                //  flash-  
                SelectedChip.Area2Size          = 2048;                 //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATmega603");  //   
                break;
    case 0xD931E:      //   ATtiny861
                SelectedChip.Name               = "ATtiny861";          //  
                SelectedChip.ImageName          = "ATtiny861.jpg";      //    
                SelectedChip.ID                 = 0xD931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny861");  //   
                break;
    case 0x8921E:      //   ATtiny461
                SelectedChip.Name               = "ATtiny461";          //  
                SelectedChip.ImageName          = "ATtiny461.jpg";      //    
                SelectedChip.ID                 = 0x8921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny461");  //   
                break;
    case 0xC911E:      //   ATtiny261
                SelectedChip.Name               = "ATtiny261";          //  
                SelectedChip.ImageName          = "ATtiny261.jpg";      //    
                SelectedChip.ID                 = 0xC911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny261");  //   
                break;
    case 0x9911E:      //   ATtiny26
                SelectedChip.Name               = "ATtiny26";           //  
                SelectedChip.ImageName          = "ATtiny26.jpg";       //    
                SelectedChip.ID                 = 0x9911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 4;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny26");   //   
                break;
    case 0xB931E:      //   ATtiny85
                SelectedChip.Name               = "ATtiny85";           //  
                SelectedChip.ImageName          = "ATtiny85.jpg";       //    
                SelectedChip.ID                 = 0xB931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 2;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny85");   //   
                break;
    case 0x6921E:      //   ATtiny45
                SelectedChip.Name               = "ATtiny45";           //  
                SelectedChip.ImageName          = "ATtiny45.jpg";       //    
                SelectedChip.ID                 = 0x6921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 2;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny45");   //   
                break;
    case 0x8911E:      //   ATtiny25
                SelectedChip.Name               = "ATtiny25";           //  
                SelectedChip.ImageName          = "ATtiny25.jpg";       //    
                SelectedChip.ID                 = 0x8911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 2;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny25");   //   
                break;
    case 0x6911E:      //   ATtiny22
                SelectedChip.Name               = "ATtiny22";           //  
                SelectedChip.ImageName          = "ATtiny22.jpg";       //    
                SelectedChip.ID                 = 0x6911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny22");   //   
                break;
    case 0x6901E:      //   ATtiny15
                SelectedChip.Name               = "ATtiny15";           //  
                SelectedChip.ImageName          = "ATtiny15.jpg";       //    
                SelectedChip.ID                 = 0x6901E;              //  
                SelectedChip.Area1Size          = 1024;                 //  flash-  
                SelectedChip.Area2Size          = 64;                   //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny15");   //   
                break;
    case 0x7901E:      //   ATtiny13
                SelectedChip.Name               = "ATtiny13";           //  
                SelectedChip.ImageName          = "ATtiny13.jpg";       //    
                SelectedChip.ID                 = 0x7901E;              //  
                SelectedChip.Area1Size          = 1024;                 //  flash-  
                SelectedChip.Area2Size          = 64;                   //  Data-  
                SelectedChip.Area3Size          = 3;                    //   (2 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny13");   //   
                break;
    case 0x5901E:      //   ATtiny12
                SelectedChip.Name               = "ATtiny12";           //  
                SelectedChip.ImageName          = "ATtiny12.jpg";       //    
                SelectedChip.ID                 = 0x5901E;              //  
                SelectedChip.Area1Size          = 1024;                 //  flash-  
                SelectedChip.Area2Size          = 64;                   //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuse + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny12");   //   
                break;
    case 0x81971E:      //   AT90CAN128
                SelectedChip.Name               = "AT90CAN128";         //  
                SelectedChip.ImageName          = "AT90CAN128.jpg";     //    
                SelectedChip.ID                 = 0x81971E;             //  
                SelectedChip.Area1Size          = 131072;               //  flash-  
                SelectedChip.Area2Size          = 4096;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90CAN128"); //   
                break;
    case 0x81961E:      //   AT90CAN64
                SelectedChip.Name               = "AT90CAN64";          //  
                SelectedChip.ImageName          = "AT90CAN64.jpg";      //    
                SelectedChip.ID                 = 0x81961E;             //  
                SelectedChip.Area1Size          = 65536;                //  flash-  
                SelectedChip.Area2Size          = 2048;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90CAN64");  //   
                break;
    case 0x81951E:      //   AT90CAN32
                SelectedChip.Name               = "AT90CAN32";          //  
                SelectedChip.ImageName          = "AT90CAN32.jpg";      //    
                SelectedChip.ID                 = 0x81951E;             //  
                SelectedChip.Area1Size          = 32768;                //  flash-  
                SelectedChip.Area2Size          = 1024;                 //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 1;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90CAN32");  //   
                break;
    case 0x3931E:       //   AT90S8535
                SelectedChip.Name               = "AT90S8535";          //  
                SelectedChip.ImageName          = "AT90S8535.jpg";      //    
                SelectedChip.ID                 = 0x3931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S4434");  //   
                break;
    case 0x2921E:       //   AT90S4434
                SelectedChip.Name               = "AT90S4434";          //  
                SelectedChip.ImageName          = "AT90S4434.jpg";      //    
                SelectedChip.ID                 = 0x2921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S4434");  //   
                break;
    case 0x1931E:       //   AT90S8515
                SelectedChip.Name               = "AT90S8515";          //  
                SelectedChip.ImageName          = "AT90S8515.jpg";      //    
                SelectedChip.ID                 = 0x1931E;              //  
                SelectedChip.Area1Size          = 8192;                 //  flash-  
                SelectedChip.Area2Size          = 512;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S8515");  //   
                break;
    case 0x1921E:       //   AT90S4414
                SelectedChip.Name               = "AT90S4414";          //  
                SelectedChip.ImageName          = "AT90S4414.jpg";      //    
                SelectedChip.ID                 = 0x1921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S4414");  //   
                break;
    case 0x3921E:       //   AT90S4433
                SelectedChip.Name               = "AT90S4433";          //  
                SelectedChip.ImageName          = "AT90S4433.jpg";      //    
                SelectedChip.ID                 = 0x3921E;              //  
                SelectedChip.Area1Size          = 4096;                 //  flash-  
                SelectedChip.Area2Size          = 256;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S4433");  //   
                break;
    case 0x5911E:       //   AT90S2333
                SelectedChip.Name               = "AT90S2333";          //  
                SelectedChip.ImageName          = "AT90S2333.jpg";      //    
                SelectedChip.ID                 = 0x5911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S2333");  //   
                break;
    case 0x3911E:       //   AT90S2343
                SelectedChip.Name               = "AT90S2343";          //  
                SelectedChip.ImageName          = "AT90S2343.jpg";      //    
                SelectedChip.ID                 = 0x3911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S2343");  //   
                break;
    case 0x2911E:       //   AT90S2323
                SelectedChip.Name               = "AT90S2323";          //  
                SelectedChip.ImageName          = "AT90S2323.jpg";      //    
                SelectedChip.ID                 = 0x2911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S2323");  //   
                break;
    case 0x1911E:       //   AT90S2313
                SelectedChip.Name               = "AT90S2313";          //  
                SelectedChip.ImageName          = "AT90S2313.jpg";      //    
                SelectedChip.ID                 = 0x1911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S2313");  //   
                break;
    case 0x1901E:       //   AT90S1200
                SelectedChip.Name               = "AT90S1200";          //  
                SelectedChip.ImageName          = "AT90S1200.jpg";      //    
                SelectedChip.ID                 = 0x1901E;              //  
                SelectedChip.Area1Size          = 1024;                 //  flash-  
                SelectedChip.Area2Size          = 64;                   //  Data-  
                SelectedChip.Area3Size          = 2;                    //   (1 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 0;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," AT90S1200");  //   
                break;
    case 0xA911E:       //   ATtiny2313
                SelectedChip.Name               = "ATtiny2313";         //  
                SelectedChip.ImageName          = "ATtiny2313.jpg";     //    
                SelectedChip.ID                 = 0xA911E;              //  
                SelectedChip.Area1Size          = 2048;                 //  flash-  
                SelectedChip.Area2Size          = 128;                  //  Data-  
                SelectedChip.Area3Size          = 4;                    //   (3 Fuses + 1 Lock)
                SelectedChip.Area4Size          = 2;                    //   
                InitFormInf(SelectedChip.ID);   //      
                SendMsgToLog(15," ATtiny2313"); //   
                break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                return;                         //        (    )
    default:    SendMsgToLog(15," unknown");    //   ,      
                return;                         //        (     )
  }
  //    
  InitArea(1); InitArea(2); InitArea(3); InitArea(4);
}
//---------------------------------------------------------------------------
//---     --------------------------------
//---------------------------------------------------------------------------
void InitArea(unsigned char Number)
{ switch(Number)
  { case 1:  //  FF-  1
             for(unsigned int i=0; i<262144; i++)
             { SelectedChip.Area1[i]=0xFF; }
             break;
    case 2:  //  FF-  2
             for(unsigned int i=0; i<65536; i++)
             { SelectedChip.Area2[i]=0xFF; }
             break;
    case 3:  //   3 FF-
             for(unsigned int i=0; i<8; i++)
             { SelectedChip.Area3[i]=0xFF; }
             //     -    
             switch(SelectedChip.ID)
             { case 0x2971E:    // ATmega128
               case 0x2961E:    // ATmega64
                                SelectedChip.Area3[0]=0xE1;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0x99;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFD;     // Extended Fuse Byte
                                SelectedChip.Area3[3]=0xFF;     // Lock Bits
                                break;
               case 0x1951E:    //   ATmega323
                                SelectedChip.Area3[0]=0xF2;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0x9F;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x2941E:    //   ATmega163
                                SelectedChip.Area3[0]=0xD2;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xFF;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x2951E:    //   ATmega32
               case 0x3941E:    //   ATmega16
                                SelectedChip.Area3[0]=0xE1;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0x99;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x8931E:    //   ATmega8535
               case 0x6931E:    //   ATmega8515
               case 0x7931E:    //   ATmega8
                                SelectedChip.Area3[0]=0xE1;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xD9;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x6941E:    // ATmega168
               case 0xA931E:    // ATmega88
                                SelectedChip.Area3[0]=0x62;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xDF;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xF9;     // Extended Fuse Byte
                                SelectedChip.Area3[3]=0xFF;     // Lock Bits
                                break;
               case 0x9911E:    //   ATtiny26
                                SelectedChip.Area3[0]=0xE1;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xF7;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x5921E:    //   ATmega48
               case 0xD931E:    //   ATtiny861
               case 0x8921E:    //   ATtiny461
               case 0xC911E:    //   ATtiny261
               case 0xB931E:    //   ATtiny85
               case 0x6921E:    //   ATtiny45
               case 0x8911E:    // ATtiny25
                                SelectedChip.Area3[0]=0x62;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xDF;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Extended Fuse Byte
                                SelectedChip.Area3[3]=0xFF;     // Lock Bits
                                break;
               case 0x6901E:    //   ATtiny15
                                SelectedChip.Area3[0]=0x5C;     // Fuse Byte
                                SelectedChip.Area3[1]=0xFF;     // Lock Bits
                                break;
               case 0x7901E:    //   ATtiny13
                                SelectedChip.Area3[0]=0x6A;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xFF;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Lock Bits
                                break;
               case 0x5901E:    //   ATtiny12
                                SelectedChip.Area3[0]=0x52;     // Fuse Byte
                                SelectedChip.Area3[1]=0xFF;     // Lock Bits
                                break;
               case 0x2981E:    //   ATmega2561
               case 0x1981E:    //   ATmega2560
               case 0x4971E:    //   ATmega1281
               case 0x3971E:    //   ATmega1280
               case 0x8961E:    //   ATmega640
               case 0x5941E:    //   ATmega169
               case 0xA961E:    //   ATmega644
               case 0x8951E:    //   ATmega324
               case 0xA941E:    //   ATmega164
               case 0x4941E:    //   ATmega162
               case 0x81971E:   //   AT90CAN128
               case 0x81961E:   //   AT90CAN64
               case 0x81951E:   //   AT90CAN32
                                SelectedChip.Area3[0]=0x62;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0x99;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Extended Fuse Byte
                                SelectedChip.Area3[3]=0xFF;     // Lock Bits
                                break;
               case 0x1941E:    //   ATmega161
               case 0x3921E:    //   AT90S4433
               case 0x5911E:    //   AT90S2333
                                SelectedChip.Area3[0]=0xDA;     // Fuse Byte (11 011010)
                                SelectedChip.Area3[1]=0xFF;     // Lock Bits
                                break;
               case 0x6911E:    //   ATtiny22
               case 0x3911E:    //   AT90S2343
               case 0x2911E:    //   AT90S2323
                                SelectedChip.Area3[0]=0xDE;     // Fuse Byte (    0)
                                SelectedChip.Area3[1]=0xFF;     // Lock Bits
                                break;
               case 0x1971E:    //   ATmega103
               case 0x1961E:    //   ATmega603
               case 0x3931E:    //   AT90S8535
               case 0x2921E:    //   AT90S4434
               case 0x1931E:    //   AT90S8515
               case 0x1921E:    //   AT90S4414
               case 0x1911E:    //   AT90S2313
               case 0x1901E:    //   AT90S1200
                                SelectedChip.Area3[0]=0xDF;     // Fuse Byte (0- , 5- )
                                SelectedChip.Area3[1]=0xFF;     // Lock Bits
                                break;
               case 0xA911E:    // ATtiny2313
                                SelectedChip.Area3[0]=0x64;     // Low Fuse Byte
                                SelectedChip.Area3[1]=0xDF;     // High Fuse Byte
                                SelectedChip.Area3[2]=0xFF;     // Extended Fuse Byte
                                SelectedChip.Area3[3]=0xFF;     // Lock Bits
                                break;
               case 0:
               default:         break;
             }
             break;
    case 4:  //  FF-  4
             for(unsigned int i=0; i<8; i++)
             { SelectedChip.Area4[i]=0xFF; }
             break;
    default: break;
  }
}
//---------------------------------------------------------------------------
//---    BIN-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromBinFileToMemory(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;              //    
  unsigned char rffch[1];       //     

  fs=new TFileStream(FilePath,fmOpenRead);      //    
  switch(Area)
  { case 1:     //  
                SendMsgToLog(10,FilePath);                              //    BIN-
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area1[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(1,1);   //   RichEdit1 Program
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(2,1);   //   RichEdit2 Program
                           break;
                  default: break;
                }
                break;
    case 2:     //  
                SendMsgToLog(11,FilePath);                              //    BIN-
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)    //   
                { if(fs->Read(rffch,1))                                 //    
                  { SelectedChip.Area2[i]=rffch[0];                     //    
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                  }
                }
                LBar->Free();                                 //    -
                //            
                switch(Form1->PageControl1->TabIndex)
                { case 0:  //   Page1
                           PlaceDataToForm(3,2);   //   RichEdit3 Data
                           break;
                  case 1:  //   Page2
                           PlaceDataToForm(4,2);   //   RichEdit4 Data
                           break;
                  default: break;
                }
                break;
    default:    break;
  }
  delete fs;                                    //   
  SendMsgToLog(12,"");                          //  
}
//---------------------------------------------------------------------------
//---    HEX-   --------------------------------
//---------------------------------------------------------------------------
void LoadFromHexFileToMemory(AnsiString FilePath, unsigned char Area)
{ AnsiString TempStr, SubStr;
  unsigned char *InBuf, OutBuf[2];                      //  
  unsigned int n, Reclen, Offset, Rectype, Address,
               LinearBaseAddress, SegmentBaseAddress;

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);        //    -
  LBar->Show();                                           //     

  switch(Area)
  { case 1:     //  
                SendMsgToLog(10,FilePath);              //    HEX-
                break;
    case 2:     //  
                SendMsgToLog(11,FilePath);              //    HEX-
                break;
    default:    break;
  }
  LinearBaseAddress=0;    SegmentBaseAddress=0;         //    

  Form1->Memo1->Clear();                                //  Memo
  Form1->Memo1->Lines->LoadFromFile(FilePath);          //    Memo
  n=Form1->Memo1->Lines->Count;                         //     
  for(unsigned int i=0;i<n;i++)                         //    
  {  TempStr=Form1->Memo1->Lines->Strings[i];           //   
     //       
     SubStr=TempStr.SubString(2,2);                     // - -     
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,1);                          //     ()
     Reclen=OutBuf[0];                                  //      
     //     
     SubStr=TempStr.SubString(4,4);                     //     
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,2);
     Offset=OutBuf[0]*256+OutBuf[1];
     //  
     SubStr=TempStr.SubString(8,2);                     //      
     InBuf=SubStr.c_str();
     HexToBin(InBuf,OutBuf,1);
     Rectype=OutBuf[0];
     switch(Rectype)
     { case 0:  // Data record
                for(unsigned int j=0;j<Reclen;j++)
                { SubStr=LowerCase(TempStr.SubString(10+2*j,2));
                  Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;//  
                  InBuf=SubStr.c_str();                                 // SubStr -     hex
                  HexToBin(InBuf,OutBuf,1);                             //      
                  switch(Area)
                  { case 1:     //  
                                if(Address<SelectedChip.Area1Size)
                                { SelectedChip.Area1[Address]=OutBuf[0];
                                }
                                break;
                    case 2:     //  
                                if(Address<SelectedChip.Area2Size)
                                { SelectedChip.Area2[Address]=OutBuf[0];
                                }
                                break;
                    default:    break;
                  }
                }
                break;
       case 1:  // End of file record
                i=n;    //   
                SendMsgToLog(12,"");                    //    
                break;
       case 2:  // Extended segment address record
                SubStr=TempStr.SubString(10,4);         // Extended segment address    
                InBuf=SubStr.c_str();
                HexToBin(InBuf,OutBuf,2);
                SegmentBaseAddress=(OutBuf[0]*256+OutBuf[1])*16;
                break;
       case 3:  // Start segment address record (  4-19   
                //  ,       )
                i=n;    //   
                SendMsgToLog(13," (from 8086/80186)");   //  HEX-  8086/80186
                break;
       case 4:  // Extended linear address record (  2    
                //  ,       )
                SubStr=TempStr.SubString(10,4);         // Extended linear address    
                InBuf=SubStr.c_str();
                HexToBin(InBuf,OutBuf,2);
                LinearBaseAddress=(OutBuf[0]*256+OutBuf[1])*65536;
                break;
       case 5:  // Start linear address record
                i=n;    //   
                SendMsgToLog(13," (from 80386)");       //  HEX-  80386
                break;
       default: //        - 
                i=n;    //   
                SendMsgToLog(13," (unknown format)");   //   
                break;
     }
     //   1024 -    -
     if(i%1024==0)
     { LBar->ProgressBar1->Position=100*(i+1)/n;
     }
  }
  Form1->Memo1->Clear();          //  Memo
  LBar->Free();                   //    -
  //            
  switch(Form1->PageControl1->TabIndex)
  { case 0:  //   Page1
             switch(Area)
             { case 1:  //  
                        PlaceDataToForm(1,1);   //   RichEdit1 Program
                        break;
               case 2:  //  
                        PlaceDataToForm(3,2);   //   RichEdit3 Data
                        break;
               default: break;
             }
             break;
    case 1:  //   Page2
             switch(Area)
             { case 1:  //  
                        PlaceDataToForm(2,1);   //   RichEdit2 Program
                        break;
               case 2:  //  
                        PlaceDataToForm(4,2);   //   RichEdit4 Data
                        break;
               default: break;
             }
             break;
    default: break;
  }
}
//---------------------------------------------------------------------------
//---      BIN- ---------------------------------
//---------------------------------------------------------------------------
void SaveFromMemoryToBinFile(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;              //    
  char Symbol[1];               //   

  switch(Area)
  { case 1:     //  
                SendMsgToLog(16,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                {     Symbol[0]=char(SelectedChip.Area1[i]);
                      fs->Write(Symbol,1);                            //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                      }
                }
                delete fs;                                            //   
                break;
    case 2:     //  
                SendMsgToLog(17,FilePath);      //      BIN-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //----------------------------------------
                //     
                //----------------------------------------
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);  //    
                for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                {     Symbol[0]=char(SelectedChip.Area2[i]);
                      fs->Write(Symbol,1);                            //   
                      //   1024 -    -
                      if(i%1024==0)
                      { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                      }
                }
                delete fs;                                            //   
                break;
    default:    break;
  }
  LBar->Free();                 //    -
  SendMsgToLog(12,"");          //  
}
//---------------------------------------------------------------------------
//---      HEX- ---------------------------------
//---------------------------------------------------------------------------
void SaveFromMemoryToHexFile(AnsiString FilePath, unsigned char Area)
{ TFileStream* fs;                      //    
  unsigned char Value[1], OutBuf[2];    //  
  unsigned char CheckSum[1];            //    

  switch(Area)
  { case 1:     //  
                SendMsgToLog(16,FilePath);              //    HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(1,1);  //    RichEdit1  Area1
                           break;
                  case 1:  GetDataToMemory(2,1);  //    RichEdit2  Area1
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<(SelectedChip.Area1Size); i++)
                { if(i%65536==0)        //   65536 -   ULBA ( 2  32-   Extended Linear Address Record)
                  { fs->Write(":02000004",9);           //     -  (:), RECLEN (0x02 = 2 ), OFFSET (0000), RECTYPE (04)
                    CheckSum[0] = 0x02;         //      RECLEN
                    CheckSum[0]+= 0x0;          //  2  OFFSET
                    CheckSum[0]+= 0x0;
                    CheckSum[0]+= 0x4;
                    Value[0] = i >> 24;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    Value[0] = i >> 16;         //     
                    CheckSum[0]+= Value[0];     //     
                    BinToHex(Value,OutBuf,1);   //   ()  
                    fs->Write(OutBuf,2);        //    
                    //     
                    CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area1[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    case 2:     //  
                SendMsgToLog(17,FilePath);              //    HEX-
                //----------------------------------------
                //       
                //----------------------------------------
                switch(Form1->PageControl1->TabIndex)
                { case 0:  GetDataToMemory(3,2);  //    RichEdit3  Area2
                           break;
                  case 1:  GetDataToMemory(4,2);  //    RichEdit4  Area2
                           break;
                  default: break;
                }
                //  -
                Application->CreateForm(__classid(TLBar),&LBar);        //    -
                LBar->Show();                                           //     
                fs = new TFileStream(FilePath,fmCreate|fmOpenWrite);    //    
                for(unsigned int i=0; i<(SelectedChip.Area2Size); i++)
                { if(i%8==0)                            //    ,     i  8  0
                  { CheckSum[0]=0x08;                   //  CheckSum      (RECLEN)
                    fs->Write(":08",3);                 //     -  (:)  RECLEN (0x08 = 8 )
                    // 
                    Value[0]=i/256;                     //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    Value[0]=i;                         //   
                    CheckSum[0]=CheckSum[0]+Value[0];   //      
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //    HEX-   

                    OutBuf[0]=0x30;                     //    RECTYPE
                    OutBuf[1]=0x30;                     // "00" - DATA RECORD  ( 0x30="0")
                    fs->Write(OutBuf,2);                //    
                  }
                  Value[0]=SelectedChip.Area2[i];       //     
                  BinToHex(Value,OutBuf,1);             //   ()  
                  fs->Write(OutBuf,2);                  //     2 
                  CheckSum[0]=CheckSum[0]+Value[0];     //      
                  //       -    CheckSum +     
                  if((i+1)%8==0)                        //     i+1  8  0
                  { CheckSum[0]=255-CheckSum[0];
                    CheckSum[0]=CheckSum[0]+1;
                    Value[0]=CheckSum[0];
                    BinToHex(Value,OutBuf,1);           //   ()  
                    fs->Write(OutBuf,2);                //   (CheckSum)  
                    Value[0]=0xD;                       //    
                    fs->Write(Value,1);
                    Value[0]=0xA;                       //     
                    fs->Write(Value,1);
                  }
                  //   1024 -    -
                  if(i%1024==0)
                  { LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;
                  }
                }
                //      
                fs->Write(":00000001FF",11);            //   
                delete fs;                              //   
                break;
    default:    break;
  }
  LBar->Free();                 //    -
  SendMsgToLog(12,"");                                  //  
}
//---------------------------------------------------------------------------
