//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"               //      
#include "LogFunctions.h"       //      
#include "PortFunctions.h"      //      
#include "FormFunctions.h"      //     
#include "About.h"              //    About
#include "ProgressBar.h"        //   -
#include "LockFuses.h"          //    LockFusesForm
#include "Image.h"              //    ImageForm
#include "ChipFunctions.h"      //     
#include "AVRFunctions.h"       //      AVR
#include "ATtiny2313.h"         //     ATtiny2313
#include "AT90S1200.h"          //     AT90S1200
#include "AT90S2313.h"          //     AT90S2313
#include "AT90S2323.h"          //     AT90S2323
#include "AT90S2343.h"          //     AT90S2343
#include "AT90S2333.h"          //     AT90S2333 / AT90S4433
#include "AT90S4414.h"          //     AT90S4414 / AT90S8515
#include "AT90S4434.h"          //     AT90S4434 / AT90S8535
#include "AT90CAN32.h"          //      AT90CAN32 / AT90CAN64 / AT90CAN128
#include "ATtiny12.h"           //      ATtiny12
#include "ATtiny13.h"           //      ATtiny13
#include "ATtiny15.h"           //      ATtiny15
#include "ATtiny22.h"           //     ATtiny22
#include "ATtiny25.h"           //      ATtiny25 / ATtiny45 / ATtiny85
#include "ATtiny26.h"           //      ATtiny26
#include "ATtiny261.h"          //      ATtiny261 / ATtiny461 / ATtiny861
#include "ATmega603.h"          //       ATmega603 / ATmega103
#include "ATmega48.h"           //      ATmega48 / ATmega88 / ATmega168
#include "ATmega8.h"            //       ATmega8
#include "ATmega8515.h"         //       ATmega8515 /ATmega8535
#include "ATmega16.h"           //       ATmega16 / ATmega32
#include "ATmega161.h"          //     ATmega161
#include "ATmega162.h"          //       ATmega162
#include "ATmega163.h"          //       ATmega163
#include "ATmega164.h"          //       ATmega164 / ATmega324 / ATmega644
#include "ATmega169.h"          //       ATmega169
#include "ATmega323.h"          //       ATmega323
#include "ATmega64.h"           //       ATmega64 / ATmega128
#include "ATmega640.h"          //       ATmega640 / ATmega1280 / ATmega1281 / ATmega2560 / ATmega2561
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
TForm1 *Form1;                  //  
unsigned int Delays;            //        
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void OpenPort()
{ //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  OpenCom(PortName);                            //     
  if(Port!=INVALID_HANDLE_VALUE)
  { EnableButtons();                            //   ,   Connect
    SendMsgToLog(1,AnsiString(PortName));       //  COM-
  }
}
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  DisableButtons();                     //   ,   Connect
  SendMsgToLog(3,"");                   // COM- 
}
//---------------------------------------------------------------------------
//---    -----------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ DisableButtons();                                     //   ,   Connect
  Form1->AutoSize               = true;                 //   
  Port                          = INVALID_HANDLE_VALUE; //    
  SelectedChip.ID               = 0;                    //     
  Delays = Form1->TrackBar1->Position;                  //   
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
//---   COM- ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
//---    COM- --------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
//---     EXIT ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
//---       ----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveLogas1Click(TObject *Sender)
{ AnsiString FilePath;                                  //    

  if(SaveDialog1->Execute())                            //     (  )
  { FilePath=SaveDialog1->FileName;                     //      ( )
    Form1->RichEdit5->Lines->SaveToFile(FilePath);      //      RichEdit5
    SendMsgToLog(8,FilePath);                           //      
  }
}
//---------------------------------------------------------------------------
//---     ABOUT --------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
//---     LOCK & FUSES... ----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::LockFuses1Click(TObject *Sender)
{ Application->CreateForm(__classid(TLockFusesForm),&LockFusesForm);    //    
  LockFusesForm->ShowModal();                                           //     
  LockFusesForm->Free();                                                //    
}
//---------------------------------------------------------------------------
//---     RH-0010 CONNECTION... ----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH0010Connection1Click(TObject *Sender)
{ Application->CreateForm(__classid(TImageForm),&ImageForm);        //     
  ImageForm->ShowModal();                                           //     
  ImageForm->Free();                                                //    
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEditsKeyPress(TObject *Sender, char &Key)
{  Key=0;
}
//---------------------------------------------------------------------------
//---   ID BYTES ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  

  Position=Form1->Edit2->SelStart;              //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                            //  
                if(Position<0)       Position=8;       //   <0,     
                else if(Position%3!=2)                  //      
                { Form1->Edit2->SelStart=Position;      //  
                  Form1->Edit2->SelLength=1;            //  1 
                  Symbol=0x46;                          //    F
                  Form1->Edit2->SelText=Symbol;         // 
                }
                //     
                Form1->Edit2->SelStart=Position;      //     
                Form1->Edit2->SelLength=0;            //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                    //   F,      
     //     ***********************
     default:   if(Position>7)       Position=-1;             //   >22,     
                else if(strchr(Charset1,Key)&&Position%3!=2)  //          
                { Form1->Edit2->SelStart=Position;            //     
                  Form1->Edit2->SelLength=1;                  //  1 
                  Symbol=Key;
                  Form1->Edit2->SelText=Symbol;               //    
                  Form1->Edit2->SelStart=Position;            //     
                  Form1->Edit2->SelLength=1;                  //  1 
                  Form1->Edit2->SelText=UpperCase(Form1->Edit2->SelText); //      
                }
                //     
                Position+=1;                          //   
                Form1->Edit2->SelStart=Position;      //     
                Form1->Edit2->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT1 (Area 1) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit1->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      80  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE1Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit1->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit1->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit1->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit1->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit1->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit1->SelLength=2;        //  2 
                  Form1->RichEdit1->SelText="FF";       // 
                }
                //     
                Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit1->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit1->SelText=Symbol;                             //    
                  Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit1->SelLength=1;                                //  1 
                  Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit1->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit1->SelLength=2;                                //  2 
                  Form1->RichEdit1->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit1->SelText=Symbol;                           //    
                    Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit1->SelLength=1;                              //  1 
                    Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit1->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit1->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit1->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit1->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit1->SelLength=1;      //  1 
                    Form1->RichEdit1->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit1->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit1->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT2 (Area 2) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit2->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      80  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE2Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit2->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit2->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit2->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit2->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit2->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit2->SelLength=2;        //  2 
                  Form1->RichEdit2->SelText="FF";       // 
                }
                //     
                Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit2->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit2->SelText=Symbol;                             //    
                  Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit2->SelLength=1;                                //  1 
                  Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit2->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit2->SelLength=2;                                //  2 
                  Form1->RichEdit2->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit2->SelText=Symbol;                           //    
                    Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit2->SelLength=1;                              //  1 
                    Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit2->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit2->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit2->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit2->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit2->SelLength=1;      //  1 
                    Form1->RichEdit2->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit2->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit2->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT3 (Area 3) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit3->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      76  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE3Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit3->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit3->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit3->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit3->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit3->SelLength=2;        //  2 
                  Form1->RichEdit3->SelText="FF";       // 
                }
                //     
                Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit3->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit3->SelText=Symbol;                             //    
                  Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit3->SelLength=1;                                //  1 
                  Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit3->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit3->SelLength=2;                                //  2 
                  Form1->RichEdit3->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit3->SelText=Symbol;                           //    
                    Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit3->SelLength=1;                              //  1 
                    Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit3->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit3->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit3->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit3->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit3->SelLength=1;      //  1 
                    Form1->RichEdit3->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit3->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit3->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---   RICHEDIT4 (Area 4) --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";              //  
  char Symbol;                                          //   
  int  PositionGlobal, LineNumber, PositionLocal;       //  ,  ,   
  int  MaxLineNumber, CharPos;                          //   ,     
  char *InHexBuf, TempBuf[1], OutHexBuf[3];             //  
  AnsiString SubStr;                                    //  

  PositionGlobal=Form1->RichEdit4->SelStart;            //     
  LineNumber=PositionGlobal/82;                         //  ,      80  + CR+LF
  PositionLocal=PositionGlobal-82*LineNumber;           //    
  MaxLineNumber=(FormData.RE4Size-1)/16;                //   
  switch(Key)
  { //  backspace ***********************************
    case 8:     PositionLocal-=1;                       //    
                if(PositionLocal<10)
                { PositionLocal=57;                     //   <6,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else if(PositionLocal<57)               //      hex
                { if ((PositionLocal-10)%3!=2)           //      
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Symbol=0x46;                        //    F
                    Form1->RichEdit4->SelText=Symbol;   // 
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit4->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           //  (TempBuf[0]      )
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else if(PositionLocal<64)               //       
                { PositionLocal=80;                     //   <36,      
                  LineNumber-=1;
                  if(LineNumber<0)                      //    <0
                        LineNumber=MaxLineNumber;       //    
                }
                else                                    //     
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //  
                  Form1->RichEdit4->SelLength=1;        //  1 
                  Symbol=0xFF;                          //    
                  Form1->RichEdit4->SelText=Symbol;     // 
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*82+10+3*CharPos;         //  
                  Form1->RichEdit4->SelLength=2;        //  2 
                  Form1->RichEdit4->SelText="FF";       // 
                }
                //     
                Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;         //     
                Form1->RichEdit4->SelLength=0;                                  //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: //      -   F
                if((PositionLocal>9) && (PositionLocal<57))
                {       Key=0x46;                    //     F
                }
                //      -   
                if(PositionLocal>63)
                {       Key=0xFF;                    //     F
                }

     //     ***********************
     default:   if(PositionLocal>79)            //   > 43
                { PositionLocal=63;             //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>63)       //   > 35
                { //   
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  if(Key<0x1F)  Key=0x1F;                                       //    () - 
                  Symbol=Key;
                  Form1->RichEdit4->SelText=Symbol;                             //    
                  Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;       //     
                  Form1->RichEdit4->SelLength=1;                                //  1 
                  Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText); //      
                  //  ,   
                  CharPos=PositionLocal-64;             //    ,   
                  TempBuf[0]=Key;
                  BinToHex(TempBuf,OutHexBuf,1);        //    ()
                  OutHexBuf[2]=0;                       //   
                  //   
                  Form1->RichEdit4->SelStart=LineNumber*82+10+3*CharPos;         //     
                  Form1->RichEdit4->SelLength=2;                                //  2 
                  Form1->RichEdit4->SelText=OutHexBuf;
                }
                else if(PositionLocal>56)       //   >52,
                { PositionLocal=9;              //     
                  LineNumber+=1;                //   
                  if(LineNumber>MaxLineNumber)
                        LineNumber=0;           //   >  -    
                }
                else if(PositionLocal>9)        //   > 5
                { if(strchr(Charset1,Key)&&((PositionLocal-10)%3!=2))            //          
                  { //   
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Symbol=Key;
                    Form1->RichEdit4->SelText=Symbol;                           //    
                    Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal;     //     
                    Form1->RichEdit4->SelLength=1;                              //  1 
                    Form1->RichEdit4->SelText=UpperCase(Form1->RichEdit4->SelText);     //      
                    //  ,      
                    CharPos=(PositionLocal-10)/3;        //    ,   
                    Form1->RichEdit4->SelStart=82*LineNumber+10+3*CharPos;       //      (  )
                    Form1->RichEdit4->SelLength=2;                              //  2 
                    SubStr=LowerCase(Form1->RichEdit4->SelText);                //    
                    InHexBuf=SubStr.c_str();            //      (  )
                    HexToBin(InHexBuf,TempBuf,1);       //    ()
                    Key=TempBuf[0];
                    if(Key<0x1F) Symbol=0x1F;           // 
                    else         Symbol=TempBuf[0];
                    //   
                    Form1->RichEdit4->SelStart=LineNumber*82+64+CharPos;        //  
                    Form1->RichEdit4->SelLength=1;      //  1 
                    Form1->RichEdit4->SelText=Symbol;   //    
                  }
                }
                else    PositionLocal=9;        //    
                //     
                PositionLocal+=1;                                       //   
                Form1->RichEdit4->SelStart=LineNumber*82+PositionLocal; //     
                Form1->RichEdit4->SelLength=0;                          //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
//---         ----------------
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadProgramfromFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,1);  //    bin-
      else                LoadFromHexFileToMemory(FilePath,1);  //    hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---         -------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ AnsiString FilePath, Ext;
  int NameLength;

  if(OpenDialog1->Execute())
  { if(SelectedChip.ID!=0)                                      //          ROM
    { FilePath=OpenDialog1->FileName;                           //    
      NameLength=FilePath.Length();                             //      
      Ext=FilePath.SubString(NameLength-2,3);                   // 
      Ext=UpperCase(Ext);                                       //    
      if(Ext=="BIN")      LoadFromBinFileToMemory(FilePath,2);  //    bin-
      else                LoadFromHexFileToMemory(FilePath,2);  //    hex-  eep-
    }
    else        SendMsgToLog(14,"");                            //   
  }
}
//---------------------------------------------------------------------------
//---         --------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveProgramtoFile1Click(TObject *Sender)
{ AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //   eep-    hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,1);        //      bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,1);        //      hex-
  }
}
//---------------------------------------------------------------------------
//---         -----------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{  AnsiString FilePath, Ext;                     //      
  int FilePathLength;                           //   
  bool SelBin, SelHex;                          //    

  SelBin=false; SelHex=false;                   //    
  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    FilePathLength=FilePath.Length();           //       
    Ext=FilePath.SubString(FilePathLength-2,3); //   ( 3 )
    Ext=UpperCase(Ext);                         //     
    //   (  )
    if(SaveDialog1->FilterIndex == 1)           //   HEX (   SaveDialog )
    { if(Ext!="HEX")    FilePath = FilePath + ".hex";   //     hex -    .hex
      SelHex=true;
    }
    else if(SaveDialog1->FilterIndex == 2)           //   EEP (   SaveDialog )
    { if(Ext!="EEP")    FilePath = FilePath + ".eep";   //     eep -    .eep
      SelHex=true;                              //  eep-     hex-
    }
    else                                        //   BIN (   HEX   EEP,     )
    { if(Ext!="BIN")    FilePath = FilePath + ".bin";   //     bin -    .bin
      SelBin=true;
    }
  }
  //------------------------------------------
  //  , ,    
  //------------------------------------------
  if(SelBin)                                    //     bin
  { SaveFromMemoryToBinFile(FilePath,2);        //      bin-
  }
  if(SelHex)                                    //     hex
  { SaveFromMemoryToHexFile(FilePath,2);        //      hex-
  }
}
//---------------------------------------------------------------------------
//---   -,    -----------
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{ Delays = Form1->TrackBar1->Position;  //    
}
//---------------------------------------------------------------------------
//////////////////////////////
//    //
//////////////////////////////
//---------------------------------------------------------------------------
//---     ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ unsigned int ChipID;  //    ID    
  WRITE_BUFFER wr_buf;  //    
  READ_BUFFER rd_buf;   //    

  if(!EnterProgrammingMode())                   //      
  {     SendMsgToLog(19," with fail.");         //   false -      
        return;                                 // 
  }

  ChipID = ReadSignatureBytes();        //       ,
  //---        ---
  //--- (    ,    -    ) ---
  if(!ExitProgrammingMode())                   //     
  {     SendMsgToLog(19," with fail.");        //   false -      
        return;                                // 
  }
  //---
  InitChip(ChipID);                     //      -   ,   
}
//---------------------------------------------------------------------------
//---   CHIP ERASE ----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{ if (Application->MessageBox("All previous chip data will be lost (Flash, EEPROM, Lock Bits). Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
  {     //  -
        Application->CreateForm(__classid(TLBar),&LBar);      //    -
        LBar->Show();                                         //     

        switch(SelectedChip.ID)
        { case 0x2981E: //   ATmega2561
          case 0x1981E: //   ATmega2560
          case 0x4971E: //   ATmega1281
          case 0x3971E: //   ATmega1280
          case 0x8961E: //   ATmega640
                        if(!ATmega640_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega640_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x2971E: //   ATmega128
          case 0x2961E: //   ATmega64
                        if(!ATmega64_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega64_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1951E: //   ATmega323
                        if(!ATmega323_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega323_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x5941E: //   ATmega169
                        if(!ATmega169_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega169_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0xA961E: //   ATmega644
          case 0x8951E: //   ATmega324
          case 0xA941E: //   ATmega164
                        if(!ATmega164_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega164_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x2941E: //   ATmega163
                        if(!ATmega163_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega163_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x4941E: //   ATmega162
                        if(!ATmega162_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega162_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1941E: //   ATmega161
                        if(!ATmega161_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega161_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x2951E: //   ATmega32
          case 0x3941E: //   ATmega16
                        if(!ATmega16_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega16_ChipErase())               //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x8931E: //   ATmega8535
          case 0x6931E: //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega8515_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x7931E: //   ATmega8
                        if(!ATmega8_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega8_ChipErase())                //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x6941E: //   ATmega168
          case 0xA931E: //   ATmega88
          case 0x5921E: //   ATmega48
                        if(!ATmega48_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega48_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1971E: //   ATmega103
          case 0x1961E: //   ATmega603
                        if(!ATmega603_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega603_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0xD931E: //   ATtiny861
          case 0x8921E: //   ATtiny461
          case 0xC911E: //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny261_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x9911E: //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny26_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0xB931E: //   ATtiny85
          case 0x6921E: //   ATtiny45
          case 0x8911E: //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny25_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x6911E: //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny22_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x6901E: //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny15_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x7901E: //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny13_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x5901E: //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny12_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_WriteFFTo0ProgramMemory()) //   0xFF     0x0
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_ChipErase())              //      (      )
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x81971E: //   AT90CAN128
          case 0x81961E: //   AT90CAN64
          case 0x81951E: //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90CAN32_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x3931E:       //   AT90S8535
          case 0x2921E:       //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S4434_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1931E:       //   AT90S8515
          case 0x1921E:       //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S4414_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x3921E:       //   AT90S4433
          case 0x5911E:       //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S2333_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x3911E:       //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S2343_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x2911E:       //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S2323_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1911E:       //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S2313_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0x1901E: //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90S1200_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0xA911E: //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny2313_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
          case 0:  SendMsgToLog(14,"");            //   ,      
                   break;                          // 
          default: SendMsgToLog(15," unknown");    //   ,      
                   break;                          // 
        }
        LBar->Free();                   //    -
  }
}
//---------------------------------------------------------------------------
//---   READ CALIBRATION ----------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{ AnsiString TempStr;                //  
  char TempBuf[1], OutHexBuf[3];     //  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  switch(SelectedChip.ID)
  { case 0x2981E:       //   ATmega2561
    case 0x1981E:       //   ATmega2560
    case 0x4971E:       //   ATmega1281
    case 0x3971E:       //   ATmega1280
    case 0x8961E:       //   ATmega640
                        if(!ATmega640_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega640_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x2971E:       //   ATmega128
    case 0x2961E:       //   ATmega64
                        if(!ATmega64_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega64_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x1951E:       //   ATmega323
                        if(!ATmega323_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega323_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x5941E:       //   ATmega169
                        if(!ATmega169_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega169_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0xA961E:       //   ATmega644
    case 0x8951E:       //   ATmega324
    case 0xA941E:       //   ATmega164
                        if(!ATmega164_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega164_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x2941E:       //   ATmega163
                        if(!ATmega163_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega163_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x4941E:       //   ATmega162
                        if(!ATmega163_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega163_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x2951E:       //   ATmega32
    case 0x3941E:       //   ATmega16
                        if(!ATmega16_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega16_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x8931E:       //   ATmega8535
    case 0x6931E:       //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega8515_ReadCalibrationBytes())  //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x7931E:       //   ATmega8
                        if(!ATmega8_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega8_ReadCalibrationBytes())     //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x6941E:       //   ATmega168
    case 0xA931E:       //   ATmega88
    case 0x5921E:       //   ATmega48
                        if(!ATmega48_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATmega48_ReadCalibrationBytes())    //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0xD931E:       //   ATtiny861
    case 0x8921E:       //   ATtiny461
    case 0xC911E:       //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny261_ReadCalibrationBytes())  //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x9911E:       //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny26_ReadCalibrationBytes())  //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0xB931E:       //   ATtiny85
    case 0x6921E:       //   ATtiny45
    case 0x8911E:       //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny25_ReadCalibrationBytes())  //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x6901E:      //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny15_ReadCalibrationBytes())   //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x7901E:      //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny13_ReadCalibrationBytes())   //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
     case 0x5901E:      //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny12_ReadCalibrationBytes())   //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x81971E:      //   AT90CAN128
    case 0x81961E:      //   AT90CAN64
    case 0x81951E:      //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!AT90CAN32_ReadCalibrationBytes())   //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0xA911E:       //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        if(!ATtiny2313_ReadCalibrationBytes())  //    
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        break;
    case 0x1941E:       //   ATmega161
    case 0x1971E:       //   ATmega103
    case 0x1961E:       //   ATmega603
    case 0x6911E:       //   ATtiny22
    case 0x3931E:       //   AT90S8535
    case 0x2921E:       //   AT90S4434
    case 0x1931E:       //   AT90S8515
    case 0x1921E:       //   AT90S4414
    case 0x3921E:       //   AT90S4433
    case 0x5911E:       //   AT90S2333
    case 0x3911E:       //   AT90S2343
    case 0x2911E:       //   AT90S2323
    case 0x1911E:       //   AT90S2313
    case 0x1901E:       //   AT90S1200
                        SendMsgToLog(20,"");            //   ,   
                        LBar->Free();                   //    -
                        return;
    case 0:     SendMsgToLog(14,"");            //   ,      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();                 //    -

  //         
  TempStr="";           //   
  for(unsigned char i=0; i<SelectedChip.Area4Size; i++)
  {     TempBuf[0]=SelectedChip.Area4[i];
        BinToHex(TempBuf,OutHexBuf,1);      //     ()
        OutHexBuf[2]=0;                     //    
        TempStr += "calibration "+IntToStr(i)+" = 0x" + AnsiString(OutHexBuf);
  }
  SendMsgToLog(0,TempStr);      //   
}
//---------------------------------------------------------------------------
//---   VERIFY PROGRAM ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  
  AnsiString TempStr;                   //     

  //        ,    
  switch(Form1->PageControl1->TabIndex)
  {       case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1
                  break;
          case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1
                  break;
          default: break;
  }

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," verify the program");       //     
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID)
  { case 0x2981E:       //   ATmega2561
    case 0x1981E:       //   ATmega2560
    case 0x4971E:       //   ATmega1281
    case 0x3971E:       //   ATmega1280
    case 0x8961E:       //   ATmega640
                        if(!ATmega640_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega640_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2971E:       //   ATmega128
    case 0x2961E:       //   ATmega64
                        if(!ATmega64_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega64_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1951E:       //   ATmega323
                        if(!ATmega323_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega323_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x5941E:       //   ATmega169
                        if(!ATmega169_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega169_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xA961E:       //   ATmega644
    case 0x8951E:       //   ATmega324
    case 0xA941E:       //   ATmega164
                        if(!ATmega164_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega164_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2941E:       //   ATmega163
                        if(!ATmega163_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega163_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x4941E:       //   ATmega162
                        if(!ATmega162_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega162_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1941E:       //   ATmega161
                        if(!ATmega161_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega161_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2951E:       //   ATmega32
    case 0x3941E:       //   ATmega16
                        if(!ATmega16_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega16_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x8931E:       //   ATmega8535
    case 0x6931E:       //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8515_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%64==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x7931E:       //   ATmega8
                        if(!ATmega8_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8_ReadProgramMemory(i,1))             //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      64-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6941E:       //   ATmega168
    case 0xA931E:       //   ATmega88
    case 0x5921E:       //   ATmega48
                        if(!ATmega48_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATmega48_ReadProgramMemory(i,1))          //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1971E:       //   ATmega103
    case 0x1961E:       //   ATmega603
                        if(!ATmega603_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega603_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xD931E:       //   ATtiny861
    case 0x8921E:       //   ATtiny461
    case 0xC911E:       //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATtiny261_ReadProgramMemory(i,1))          //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x9911E:       //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny26_ReadProgramMemory(i,1))          //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xB931E:       //   ATtiny85
    case 0x6921E:       //   ATtiny45
    case 0x8911E:       //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny25_ReadProgramMemory(i,1))          //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6911E:       //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny22_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6901E:       //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny15_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x7901E:       //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny13_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x5901E:       //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny12_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x81971E:      //   AT90CAN128
    case 0x81961E:      //   AT90CAN64
    case 0x81951E:      //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90CAN32_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      256-
                                if((i+2)%256==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3931E:       //   AT90S8535
    case 0x2921E:       //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4434_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1931E:       //   AT90S8515
    case 0x1921E:       //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4414_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3921E:       //   AT90S4433
    case 0x5911E:       //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S2333_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3911E:       //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2343_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2911E:       //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2323_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1911E:       //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S2313_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1901E:       //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S1200_ReadProgramMemory(i,1))           //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xA911E:       //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!ATtiny2313_ReadProgramMemory(i,1))          //    
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  SendMsgToLog(19,". No differences found.");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   VERIFY DATA ---------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{ char TempBuf[1], OutHexBuf[3];        //  
  AnsiString TempStr;                   //     

  //        ,    
  switch(Form1->PageControl1->TabIndex)
  {       case 0: GetDataToMemory(3,2);      //  RichEdit3  Area2
                  break;
          case 1: GetDataToMemory(4,2);      //  RichEdit4  Area2
                  break;
          default: break;
  }

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," verify the EEPROM");        //     EEPROM
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID)
  { case 0x2981E:       //   ATmega2561
    case 0x1981E:       //   ATmega2560
    case 0x4971E:       //   ATmega1281
    case 0x3971E:       //   ATmega1280
    case 0x8961E:       //   ATmega640
                        if(!ATmega640_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega640_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2971E:       //   ATmega128
    case 0x2961E:       //   ATmega64
                        if(!ATmega64_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega64_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1951E:       //   ATmega323
                        if(!ATmega323_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega323_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x5941E:       //   ATmega169
                        if(!ATmega169_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega169_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xA961E:       //   ATmega644
    case 0x8951E:       //   ATmega324
    case 0xA941E:       //   ATmega164
                        if(!ATmega164_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega164_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2941E:       //   ATmega163
                        if(!ATmega163_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega163_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x4941E:       //   ATmega162
                        if(!ATmega162_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega162_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1941E:       //   ATmega161
                        if(!ATmega161_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega161_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2951E:       //   ATmega32
    case 0x3941E:       //   ATmega16
                        if(!ATmega16_ProgrammingEnable())       //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega16_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x8931E:       //   ATmega8535
    case 0x6931E:       //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega8515_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x7931E:       //   ATmega8
                        if(!ATmega8_ProgrammingEnable())        //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega8_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6941E:       //   ATmega168
    case 0xA931E:       //   ATmega88
    case 0x5921E:       //   ATmega48
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega48_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1971E:       //   ATmega103
    case 0x1961E:       //   ATmega603
                        if(!ATmega603_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega603_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xD931E:       //   ATtiny861
    case 0x8921E:       //   ATtiny461
    case 0xC911E:       //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny261_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x9911E:       //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny26_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xB931E:       //   ATtiny85
    case 0x6921E:       //   ATtiny45
    case 0x8911E:       //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny25_ReadEEPROMMemory(i,1))             //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6911E:       //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny22_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6901E:       //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny15_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x7901E:       //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny13_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x5901E:       //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny12_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x81971E:      //   AT90CAN128
    case 0x81961E:      //   AT90CAN64
    case 0x81951E:      //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90CAN32_ReadEEPROMMemory(i,1))                           //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      8-
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3931E:       //   AT90S8535
    case 0x2921E:       //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S4434_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1931E:       //   AT90S8515
    case 0x1921E:       //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S4414_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3921E:       //   AT90S4433
    case 0x5911E:       //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2333_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3911E:       //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2343_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2911E:       //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2323_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1911E:       //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2313_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1901E:       //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S1200_ReadEEPROMMemory(i,1))            //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xA911E:       //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny2313_ReadEEPROMMemory(i,1))                           //    EEPROM
                                {       TempBuf[0]=i>>8;                        //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr=UpperCase(OutHexBuf);           //        
                                        TempBuf[0]=i;                           //    
                                        BinToHex(TempBuf,OutHexBuf,1);          //   
                                        OutHexBuf[2]=0;                         //    
                                        TempStr+=UpperCase(OutHexBuf);          //        

                                        SendMsgToLog(19," with fail. Address: 0x" + TempStr);   //   false -  
                                        SendEndTimeToLog();                                     //      
                                        LBar->Free();                                           //    -
                                        return;                                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  SendMsgToLog(19,". No differences found.");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   WRITE PROGRAM -------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ if (Application->MessageBox("All previous chip data will be lost (Flash, EEPROM, Lock Bits). Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
  {     //        ,    
        switch(Form1->PageControl1->TabIndex)
        {       case 0: GetDataToMemory(1,1);      //  RichEdit1  Area1
                        break;
                case 1: GetDataToMemory(2,1);      //  RichEdit2  Area1
                        break;
                default: break;
        }

        //  -
        Application->CreateForm(__classid(TLBar),&LBar);      //    -
        LBar->Show();                                         //     

        SendMsgToLog(18," write the program");        //     
        SendStartTimeToLog();                         //      
        switch(SelectedChip.ID)
        { case 0x2981E: //   ATmega2561
          case 0x1981E: //   ATmega2560
          case 0x4971E: //   ATmega1281
          case 0x3971E: //   ATmega1280
          case 0x8961E: //   ATmega640
                        if(!ATmega640_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega640_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega640_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega640_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256- (  = 128  = 256 ) -     
                                if((i+2)%256==0)
                                {       if(!ATmega640_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x2971E: //   ATmega128
          case 0x2961E: //   ATmega64
                        if(!ATmega64_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega64_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega64_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega64_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256- (  = 128  = 256 ) -     
                                if((i+2)%256==0)
                                {       if(!ATmega64_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1951E: //   ATmega323
                        if(!ATmega323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega323_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega323_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega323_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x5941E: //   ATmega169
                        if(!ATmega169_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega169_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega169_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega169_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega169_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xA961E: //   ATmega644
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega164_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega164_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256- (  = 128  = 256 ) -     
                                if((i+2)%256==0)
                                {       if(!ATmega164_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x8951E: //   ATmega324
          case 0xA941E: //   ATmega164
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega164_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega164_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega164_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x2941E: //   ATmega163
                        if(!ATmega163_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega163_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega163_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega163_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega163_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x4941E: //   ATmega162
                        if(!ATmega162_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega162_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega162_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega162_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega162_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1941E: //   ATmega161
                        if(!ATmega161_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega161_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega161_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega161_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega161_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x2951E: //   ATmega32
          case 0x3941E: //   ATmega16
                        if(!ATmega16_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega16_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega16_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega16_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega16_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x8931E: //   ATmega8535
          case 0x6931E: //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega8515_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8515_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64- (  = 32  = 64 ) -     
                                if((i+2)%64==0)
                                {       if(!ATmega8515_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x7931E: //   ATmega8
                        if(!ATmega8_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega8_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega8_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64- (  = 32  = 64 ) -     
                                if((i+2)%64==0)
                                {       if(!ATmega8_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x6941E:       //   ATmega168
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega48_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega48_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      128- (  = 64  = 128 ) -     
                                if((i+2)%128==0)
                                {       if(!ATmega48_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xA931E: //   ATmega88
          case 0x5921E: //   ATmega48
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega48_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega48_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64- (  = 32  = 64 ) -     
                                if((i+2)%64==0)
                                {       if(!ATmega48_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1971E: //   ATmega103
          case 0x1961E: //   ATmega603
                        if(!ATmega603_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATmega603_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATmega603_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega603_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256 (  = 128  = 256 ) -     
                                if((i+2)%256==0)
                                {       if(!ATmega603_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xD931E: //   ATtiny861
          case 0x8921E: //   ATtiny461
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny261_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATtiny261_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64- (  = 32  = 64 ) -     
                                if((i+2)%64==0)
                                {       if(!ATtiny261_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xC911E: //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny261_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATtiny261_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- (  = 16  = 32 ) -     
                                if((i+2)%32==0)
                                {       if(!ATtiny261_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x9911E: //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny26_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny26_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- (  = 16  = 32 ) -     
                                if((i+1)%32==0)
                                {       if(!ATtiny26_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xB931E: //   ATtiny85
          case 0x6921E: //   ATtiny45
          case 0x8911E: //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny25_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny25_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- (  = 16  = 32 ) -     
                                if((i+1)%32==0)
                                {       if(!ATtiny25_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x6911E: //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny22_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny22_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny22_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x6901E: //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny15_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny15_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny15_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x7901E: //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny13_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny13_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny13_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- (  = 16  = 32 ) -     
                                if((i+1)%32==0)
                                {       if(!ATtiny13_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x5901E: //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //        ,       
                        if(!ATtiny12_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_WriteFFTo0ProgramMemory()) //   0xFF     0x0
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        if(!ATtiny12_ChipErase())              //      (      )
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny12_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny12_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x81971E://   AT90CAN128
          case 0x81961E://   AT90CAN64
          case 0x81951E://   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90CAN32_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90CAN32_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90CAN32_LoadProgramMemoryPage(i))         //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256- (  = 128  = 256 ) -     
                                if((i+2)%256==0)
                                {       if(!AT90CAN32_WriteProgramMemoryPage(i))        //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x3931E: //   AT90S8535
          case 0x2921E: //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S4434_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S4434_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4434_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1931E: //   AT90S8515
          case 0x1921E: //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S4414_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S4414_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4414_WriteProgramMemory(i))            //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x3921E: //   AT90S4433
          case 0x5911E: //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S2333_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S2333_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S2333_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x3911E: //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S2343_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S2343_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2343_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x2911E: //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S2323_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S2323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2323_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1911E: //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S2313_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S2313_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0x1901E: //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!AT90S1200_ChipErase())              //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!AT90S1200_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S1200_WriteProgramMemory(i))            //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- -   progress bara
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0xA911E: //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        // ,    , -   
                        if(!ATtiny2313_ChipErase())             //   
                        {       SendMsgToLog(19," with fail."); //   false -   
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //     ProgrammingEnable   
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATtiny2313_LoadProgramMemoryPage(i))        //     
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32- (  = 16  = 32 ) -     
                                if((i+2)%32==0)
                                {       if(!ATtiny2313_WriteProgramMemoryPage(i))       //     
                                        {       SendMsgToLog(19," with fail.");         //   false -   
                                                SendEndTimeToLog();                     //      
                                                LBar->Free();                           //    -
                                                return;                                 // 
                                        }
                                        LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
          case 0:  SendMsgToLog(14,"");            //   ,      
                   SendEndTimeToLog();             //      
                   LBar->Free();                   //    -
                   return;                         // 
          default: SendMsgToLog(15," unknown");    //   ,      
                   SendEndTimeToLog();             //      
                   LBar->Free();                   //    -
                   return;                         // 
        }
        LBar->Free();         //    -
        SendMsgToLog(19,"");  //    
        SendEndTimeToLog();   //      
  }
}
//---------------------------------------------------------------------------
//---   WRITE DATA ----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{ if (Application->MessageBox("All previous chip data will be lost (EEPROM). Are you sure?", "Warning", MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL) == IDYES)
  { //        ,    
    switch(Form1->PageControl1->TabIndex)
    {   case 0: GetDataToMemory(3,2);      //  RichEdit3  Area2
                break;
        case 1: GetDataToMemory(4,2);      //  RichEdit4  Area2
                break;
        default: break;
    }

    //  -
    Application->CreateForm(__classid(TLBar),&LBar);      //    -
    LBar->Show();                                         //     

    SendMsgToLog(18," write the EEPROM");    //     EEPROM
    SendStartTimeToLog();                    //      
    switch(SelectedChip.ID)
    { case 0x2981E:   //   ATmega2561
      case 0x1981E:   //   ATmega2560
      case 0x4971E:   //   ATmega1281
      case 0x3971E:   //   ATmega1280
      case 0x8961E:   //   ATmega640
                       if(!ATmega640_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega640_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x2971E:   //   ATmega128
      case 0x2961E:   //   ATmega64
                       if(!ATmega64_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega64_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1951E:   //   ATmega323
                       if(!ATmega323_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega323_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x5941E:   //   ATmega169
                       if(!ATmega169_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega169_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0xA961E:   //   ATmega644
                       if(!ATmega164_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega164_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      8- -   progress bara
                               if((i+1)%8==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x8951E:   //   ATmega324
      case 0xA941E:   //   ATmega164
                       if(!ATmega164_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega164_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x2941E:   //   ATmega163
                       if(!ATmega163_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega163_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x4941E:   //   ATmega162
                       if(!ATmega162_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega162_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1941E:   //   ATmega161
                       if(!ATmega161_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega161_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x2951E:   //   ATmega32
      case 0x3941E:   //   ATmega16
                       if(!ATmega16_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega16_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x8931E:   //   ATmega8535
      case 0x6931E:   //   ATmega8515
                       if(!ATmega8515_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega8515_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x7931E:   //   ATmega8
                       if(!ATmega8_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega8_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x6941E:   //   ATmega168
      case 0xA931E:   //   ATmega88
      case 0x5921E:   //   ATmega48
                       if(!ATmega48_ProgrammingEnable())       //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega48_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1971E:   //   ATmega103
      case 0x1961E:   //   ATmega603
                       if(!ATmega603_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATmega603_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      32- -   progress bara
                               if((i+1)%32==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0xD931E:   //   ATtiny861
      case 0x8921E:   //   ATtiny461
      case 0xC911E:   //   ATtiny261
                       if(!ATtiny261_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny261_WriteEEPROMMemory(i))             //          
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- ( ) -     
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x9911E:   //   ATtiny26
                       if(!ATtiny26_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny26_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0xB931E:   //   ATtiny85
      case 0x6921E:   //   ATtiny45
      case 0x8911E:   //   ATtiny25
                       if(!ATtiny25_ProgrammingEnable())     //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny25_LoadEEPROMMemoryPage(i))         //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- ( ) -     
                               if((i+1)%4==0)
                               {       if(!ATtiny25_WriteEEPROMMemoryPage(i))        //     
                                       {       SendMsgToLog(19," with fail.");         //   false -   
                                               SendEndTimeToLog();             //      
                                               LBar->Free();                           //    -
                                               return;                                 // 
                                       }
                                       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x6911E:   //   ATtiny22
                       if(!ATtiny22_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny22_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x6901E:   //   ATtiny15
                       if(!ATtiny15_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny15_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x7901E:   //   ATtiny13
                       if(!ATtiny13_ProgrammingEnable())     //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny13_LoadEEPROMMemoryPage(i))         //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- ( ) -     
                               if((i+1)%4==0)
                               {       if(!ATtiny13_WriteEEPROMMemoryPage(i))        //     
                                       {       SendMsgToLog(19," with fail.");         //   false -   
                                               SendEndTimeToLog();             //      
                                               LBar->Free();                           //    -
                                               return;                                 // 
                                       }
                                       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x5901E:   //   ATtiny12
                       if(!ATtiny12_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny12_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x81971E:   //   AT90CAN128
      case 0x81961E:   //   AT90CAN64
      case 0x81951E:   //   AT90CAN32
                       if(!AT90CAN32_ProgrammingEnable())     //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90CAN32_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      8- ( ) -     
                               if((i+1)%8==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x3931E:   //   AT90S8535
      case 0x2921E:   //   AT90S4434
                       if(!AT90S4434_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S4434_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1931E:   //   AT90S8515
      case 0x1921E:   //   AT90S4414
                       if(!AT90S4414_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S4414_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x3921E:   //   AT90S4433
      case 0x5911E:   //   AT90S2333
                       if(!AT90S2333_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S2333_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x3911E:   //   AT90S2343
                       if(!AT90S2343_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S2343_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x2911E:   //   AT90S2323
                       if(!AT90S2323_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S2323_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1911E:   //   AT90S2313
                       if(!AT90S2313_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S2313_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0x1901E:   //   AT90S1200
                       if(!AT90S1200_ProgrammingEnable())      //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!AT90S1200_WriteEEPROMMemory(i))             //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- -   progress bara
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0xA911E:   //   ATtiny2313
                       if(!ATtiny2313_ProgrammingEnable())     //          
                       {       SendMsgToLog(19," with fail."); //   false -   
                               SendEndTimeToLog();             //      
                               LBar->Free();                   //    -
                               return;                         // 
                       }
                       //      
                       for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                       {       if(!ATtiny2313_WriteEEPROMMemory(i))            //     
                               {       SendMsgToLog(19," with fail.");         //   false -   
                                       SendEndTimeToLog();                     //      
                                       LBar->Free();                           //    -
                                       return;                                 // 
                               }
                               //      4- ( ) -     
                               if((i+1)%4==0)
                               {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                               }
                       }
                       break;
      case 0:  SendMsgToLog(14,"");            //   ,      
               SendEndTimeToLog();             //      
               LBar->Free();                   //    -
               return;                         // 
      default: SendMsgToLog(15," unknown");    //   ,      
               SendEndTimeToLog();             //      
               LBar->Free();                   //    -
               return;                         // 
    }
    LBar->Free();         //    -
    SendMsgToLog(19,"");  //    
    SendEndTimeToLog();   //      
  }
}
//---------------------------------------------------------------------------
//---   READ PROGRAM --------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," read the program");         //     
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID)
  { case 0x2981E:       //   ATmega2561
    case 0x1981E:       //   ATmega2560
    case 0x4971E:       //   ATmega1281
    case 0x3971E:       //   ATmega1280
    case 0x8961E:       //   ATmega640
                        if(!ATmega640_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega640_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2971E:       //   ATmega128
    case 0x2961E:       //   ATmega64
                        if(!ATmega64_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega64_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1951E:       //   ATmega323
                        if(!ATmega323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega323_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x5941E:       //   ATmega169
                        if(!ATmega169_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega169_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xA961E:       //   ATmega644
    case 0x8951E:       //   ATmega324
    case 0xA941E:       //   ATmega164
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega164_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2941E:       //   ATmega163
                        if(!ATmega163_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega163_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x4941E:       //   ATmega162
                        if(!ATmega162_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega162_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1941E:       //   ATmega161
                        if(!ATmega161_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega161_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2951E:       //   ATmega32
    case 0x3941E:       //   ATmega16
                        if(!ATmega16_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega16_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x8931E:       //   ATmega8535
    case 0x6931E:       //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8515_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64-
                                if((i+2)%64==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x7931E:       //   ATmega8
                        if(!ATmega8_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega8_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      64-
                                if((i+2)%64==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6941E:       //   ATmega168
    case 0xA931E:       //   ATmega88
    case 0x5921E:       //   ATmega48
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega48_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1971E:       //   ATmega103
    case 0x1961E:       //   ATmega603
                        if(!ATmega603_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATmega603_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256
                                if((i+2)%256==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xD931E:       //   ATtiny861
    case 0x8921E:       //   ATtiny461
    case 0xC911E:       //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)
                        {       if(!ATtiny261_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x9911E:       //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny26_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xB931E:       //   ATtiny85
    case 0x6921E:       //   ATtiny45
    case 0x8911E:       //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny25_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6911E:       //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny22_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x6901E:       //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny15_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x7901E:       //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny13_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x5901E:       //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!ATtiny12_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x81971E:      //   AT90CAN128
    case 0x81961E:      //   AT90CAN64
    case 0x81951E:      //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90CAN32_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      256-
                                if((i+2)%256==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3931E:       //   AT90S8535
    case 0x2921E:       //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4434_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1931E:       //   AT90S8515
    case 0x1921E:       //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S4414_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3921E:       //   AT90S4433
    case 0x5911E:       //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)    //   
                        {       if(!AT90S2333_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x3911E:       //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2343_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x2911E:       //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i++)
                        {       if(!AT90S2323_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1911E:       //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S2313_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0x1901E:       //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!AT90S1200_ReadProgramMemory(i,0))           //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0xA911E:       //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //      
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area1Size; i+=2)   //   
                        {       if(!ATtiny2313_ReadProgramMemory(i,0))          //    
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+2)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+2)/SelectedChip.Area1Size;  //    -
                                }
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  //        
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(1,1);      //  RichEdit1  Area1
                break;
        case 1: PlaceDataToForm(2,1);      //  RichEdit2  Area1
                break;
        default: break;
  }
  SendMsgToLog(19,"");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---   READ DATA -----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{ //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  SendMsgToLog(18," read the EEPROM");          //     
  SendStartTimeToLog();                         //      
  switch(SelectedChip.ID)
  { case 0x2981E:       //   ATmega2561
    case 0x1981E:       //   ATmega2560
    case 0x4971E:       //   ATmega1281
    case 0x3971E:       //   ATmega1280
    case 0x8961E:       //   ATmega640
                        if(!ATmega640_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega640_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2971E:       //   ATmega128
    case 0x2961E:       //   ATmega64
                        if(!ATmega64_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega64_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1951E:       //   ATmega323
                        if(!ATmega323_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega323_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x5941E:       //   ATmega169
                        if(!ATmega169_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega169_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xA961E:       //   ATmega644
    case 0x8951E:       //   ATmega324
    case 0xA941E:       //   ATmega164
                        if(!ATmega164_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega164_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2941E:       //   ATmega163
                        if(!ATmega163_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega163_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x4941E:       //   ATmega162
                        if(!ATmega162_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega162_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1941E:       //   ATmega161
                        if(!ATmega161_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega161_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2951E:       //   ATmega32
    case 0x3941E:       //   ATmega16
                        if(!ATmega16_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega16_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x8931E:       //   ATmega8535
    case 0x6931E:       //   ATmega8515
                        if(!ATmega8515_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega8515_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x7931E:       //   ATmega8
                        if(!ATmega8_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega8_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6941E:       //   ATmega168
    case 0xA931E:       //   ATmega88
    case 0x5921E:       //   ATmega48
                        if(!ATmega48_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega48_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1971E:       //   ATmega103
    case 0x1961E:       //   ATmega603
                        if(!ATmega603_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATmega603_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      32-
                                if((i+1)%32==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xD931E:       //   ATtiny861
    case 0x8921E:       //   ATtiny461
    case 0xC911E:       //   ATtiny261
                        if(!ATtiny261_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny261_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x9911E:       //   ATtiny26
                        if(!ATtiny26_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny26_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xB931E:       //   ATtiny85
    case 0x6921E:       //   ATtiny45
    case 0x8911E:       //   ATtiny25
                        if(!ATtiny25_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny25_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6911E:       //   ATtiny22
                        if(!ATtiny22_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny22_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x6901E:       //   ATtiny15
                        if(!ATtiny15_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny15_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x7901E:       //   ATtiny13
                        if(!ATtiny13_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny13_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x5901E:       //   ATtiny12
                        if(!ATtiny12_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny12_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x81971E:       //   AT90CAN128
    case 0x81961E:       //   AT90CAN64
    case 0x81951E:       //   AT90CAN32
                        if(!AT90CAN32_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90CAN32_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      8-
                                if((i+1)%8==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3931E:       //   AT90S8535
    case 0x2921E:       //   AT90S4434
                        if(!AT90S4434_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S4434_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1931E:       //   AT90S8515
    case 0x1921E:       //   AT90S4414
                        if(!AT90S4414_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S4414_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3921E:       //   AT90S4433
    case 0x5911E:       //   AT90S2333
                        if(!AT90S2333_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2333_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x3911E:       //   AT90S2343
                        if(!AT90S2343_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2343_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x2911E:       //   AT90S2323
                        if(!AT90S2323_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2323_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1911E:       //   AT90S2313
                        if(!AT90S2313_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S2313_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0x1901E:       //   AT90S1200
                        if(!AT90S1200_ProgrammingEnable())      //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!AT90S1200_ReadEEPROMMemory(i,0))            //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0xA911E:       //   ATtiny2313
                        if(!ATtiny2313_ProgrammingEnable())     //          
                        {       SendMsgToLog(19," with fail."); //   false -   
                                SendEndTimeToLog();             //      
                                LBar->Free();                   //    -
                                return;                         // 
                        }
                        //      
                        for(unsigned int i=0; i<SelectedChip.Area2Size; i++)
                        {       if(!ATtiny2313_ReadEEPROMMemory(i,0))           //    EEPROM
                                {       SendMsgToLog(19," with fail.");         //   false -   
                                        SendEndTimeToLog();                     //      
                                        LBar->Free();                           //    -
                                        return;                                 // 
                                }
                                //      4-
                                if((i+1)%4==0)
                                {       LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Area2Size;  //    -
                                }
                        }
                        break;
    case 0:     SendMsgToLog(14,"");            //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
    default:    SendMsgToLog(15," unknown");    //   ,      
                SendEndTimeToLog();             //      
                LBar->Free();                   //    -
                return;                         // 
  }
  LBar->Free();         //    -
  //        
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(3,2);      //  RichEdit3  Area2
                break;
        case 1: PlaceDataToForm(4,2);      //  RichEdit4  Area2
                break;
        default: break;
  }
  SendMsgToLog(19,"");  //    
  SendEndTimeToLog();   //      
}
//---------------------------------------------------------------------------
//---      ATtiny2313 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::tiny23131Click(TObject *Sender)
{ InitChip(0xA911E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S1200 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S12001Click(TObject *Sender)
{ InitChip(0x1901E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S2313 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S23131Click(TObject *Sender)
{ InitChip(0x1911E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S2323 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S23231Click(TObject *Sender)
{ InitChip(0x2911E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S2343 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S23431Click(TObject *Sender)
{ InitChip(0x3911E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S2333 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S23331Click(TObject *Sender)
{ InitChip(0x5911E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S4433 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S44331Click(TObject *Sender)
{ InitChip(0x3921E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S4414 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S44141Click(TObject *Sender)
{ InitChip(0x1921E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S8515 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S85151Click(TObject *Sender)
{ InitChip(0x1931E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S4434 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S44341Click(TObject *Sender)
{ InitChip(0x2921E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90S8535 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90S85351Click(TObject *Sender)
{ InitChip(0x3931E);                    //   ,   
}
//---------------------------------------------------------------------------
//---      AT90CAN32 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90CAN321Click(TObject *Sender)
{ InitChip(0x81951E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      AT90CAN64 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90CAN641Click(TObject *Sender)
{ InitChip(0x81961E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      AT90CAN128 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::AT90CAN1281Click(TObject *Sender)
{ InitChip(0x81971E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY12 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny121Click(TObject *Sender)
{ InitChip(0x5901E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY13 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny131Click(TObject *Sender)
{ InitChip(0x7901E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY15 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny151Click(TObject *Sender)
{ InitChip(0x6901E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY22 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny221Click(TObject *Sender)
{ InitChip(0x6911E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY25 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny251Click(TObject *Sender)
{ InitChip(0x8911E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY45 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny451Click(TObject *Sender)
{ InitChip(0x6921E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY85 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny851Click(TObject *Sender)
{ InitChip(0xB931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY26 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny261Click(TObject *Sender)
{ InitChip(0x9911E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY26 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny2611Click(TObject *Sender)
{ InitChip(0xC911E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY461 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny4611Click(TObject *Sender)
{ InitChip(0x8921E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATTINY861 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATtiny8611Click(TObject *Sender)
{ InitChip(0xD931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA603 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega6031Click(TObject *Sender)
{ InitChip(0x1961E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA103 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1031Click(TObject *Sender)
{ InitChip(0x1971E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA48 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega481Click(TObject *Sender)
{ InitChip(0x5921E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA88 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega881Click(TObject *Sender)
{ InitChip(0xA931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA88 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1681Click(TObject *Sender)
{ InitChip(0x6941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA8 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega81Click(TObject *Sender)
{ InitChip(0x7931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA8515 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega85151Click(TObject *Sender)
{ InitChip(0x6931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA8535 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega85351Click(TObject *Sender)
{ InitChip(0x8931E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA16 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega161Click(TObject *Sender)
{ InitChip(0x3941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA161 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1611Click(TObject *Sender)
{ InitChip(0x1941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA162 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1621Click(TObject *Sender)
{ InitChip(0x4941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA163 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1631Click(TObject *Sender)
{ InitChip(0x2941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA164 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1641Click(TObject *Sender)
{ InitChip(0xA941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA324 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega3241Click(TObject *Sender)
{ InitChip(0x8951E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA644 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega6441Click(TObject *Sender)
{ InitChip(0xA961E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA169 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1691Click(TObject *Sender)
{ InitChip(0x5941E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA32 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega321Click(TObject *Sender)
{ InitChip(0x2951E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA323 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega3231Click(TObject *Sender)
{ InitChip(0x1951E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA64 --------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega641Click(TObject *Sender)
{ InitChip(0x2961E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA640 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega6401Click(TObject *Sender)
{ InitChip(0x8961E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA1280 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega12801Click(TObject *Sender)
{ InitChip(0x3971E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA1281 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega12811Click(TObject *Sender)
{ InitChip(0x4971E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA2560 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega25601Click(TObject *Sender)
{ InitChip(0x1981E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA2561 ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega25611Click(TObject *Sender)
{ InitChip(0x2981E);                   //   ,   
}
//---------------------------------------------------------------------------
//---      ATMEGA128 -------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::ATmega1281Click(TObject *Sender)
{ InitChip(0x2971E);                   //   ,   
}
//---------------------------------------------------------------------------
